﻿;
var eamGridsDataModule = (function($) {
    "use strict";

    var _defaultRefreshInterval = 60,
        _refreshEnabled = true,
        _secondssinceloaded = 0,
        _refreshRateCookieName = 'com.bluedotsolutions.eamgridsdata.refreshrate',
        _refreshinterval,
        _starttime,
        _nowtime,
        _reloadseconds,
        _timer,
        _counterControl,
        _intervalInputId;

    var _initialize = function(intervalInputId, btnUpdate) {
        _intervalInputId = intervalInputId;

        $('#' + btnUpdate).on('click', _saveRefreshRate);

        // try to load interval from cookie
        _refreshinterval = _defaultRefreshInterval;
        var cookieInterval = parseInt(_getCookie(_refreshRateCookieName));
        if (cookieInterval !== NaN && cookieInterval > 0)
            _refreshinterval = cookieInterval;

        $('#' + intervalInputId).val(_refreshinterval.toString());
    };

    var _saveRefreshRate = function() {
        var interval = parseInt($('#' + _intervalInputId).val());
        if (isNaN(interval))
            return;

        if (interval < _defaultRefreshInterval)
            interval = _defaultRefreshInterval;

        _setCookie(_refreshRateCookieName, interval, 90);
        location.reload(true);
    }

    var _countdown = function() {
        _nowtime = (new Date()).getTime();

        _secondssinceloaded = (_nowtime - _starttime) / 1000;
        _reloadseconds = Math.round(_refreshinterval - _secondssinceloaded);
        if (_refreshinterval >= _secondssinceloaded) {
            _timer = setTimeout(function() { _countdown(); }, 1000);
            if (_refreshEnabled) {
                _counterControl.text(_reloadseconds.toString());
            }
        } else {
            clearTimeout(_timer);

            if (_refreshEnabled) {
                location.reload(true);
            }
        }
    };

    var _startAutoRefreshTimer = function(counterId) {
        _counterControl = $('#' + counterId);
        _starttime = (new Date()).getTime();
        _secondssinceloaded = 0;
        _countdown();
    };

    var _setCookie = function(name, value, days) {
        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            var expires = "; expires=" + date.toGMTString();
        } else var expires = "";
        document.cookie = name + "=" + value + expires + "; path=/";
    }

    var _getCookie = function(name) {
        var nameEQ = name + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1, c.length);
            if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
        }
        return null;
    }

    //public
    return {
        Initialize: _initialize,
        StartAutoRefreshTimer: _startAutoRefreshTimer
    }
})(jQuery);

// execute when page is loaded
$(function() {
    eamGridsDataModule.Initialize("refresh-rate", "update-refresh-rate");
    eamGridsDataModule.StartAutoRefreshTimer("refresh-counter");
});


